var OutputLength;
var TextInput;
var TextOutput;
var TextCursor;
var PreText;

var TimeNextAction;
var CursorTimer;
var StartTimeFadeout;


var TimeBetweenChars;
var DisplayTime;
var FadeOutTime;
var CursorShow;



var FontOpacity;
var StatemachineState=0;

var CursorChar = '|'; //could also be '|' '█'

//arguments[0]: PreText
//arguments[1]: Text to display
//arguments[2]: TimeBetweenChars (0: Random, positive: time in ms)
//arguments[3]: Display time ms
//arguments[4]: Fadeout time ms
//arguments[5]: Cursor Show (0: not shown)
//arguments[6]: 1: Reset Output

//output[0]: Text
//output[1]: FontOpacity

function main()
{
	var CurrentTime= new Date()*1;

	PreText=arguments[0];
	TimeBetweenChars=arguments[2];
	DisplayTime=arguments[3]*1000;
	FadeOutTime=arguments[4]*1000;
	CursorShow=arguments[5];
	
	
	if (TextInput!=arguments[1] || arguments[6]==1)
	{
		//reset statemachine
		StatemachineState=0;
		DebugOutput('DisplayTime', DisplayTime);
		DebugOutput('FadeOutTime', FadeOutTime);

	}
	
	switch(StatemachineState) {
		case 0://Reset
			//save text input
			TextInput=arguments[1];
			//reset output
			TextOutput='';
			TextCursor='';
			//reset output length
			OutputLength=0;
			//save start time
			TimeNextAction=CurrentTime+NextCharDelay()+100;
			//set Opacity to full value
			FontOpacity=100.0;			
			
			StatemachineState=1;
			break;
			
		case 1: //Display Chars;
			if(TimeNextAction-CurrentTime<0)
			{
				//display the next char
				if(OutputLength<TextInput.length)
				{
					OutputLength=OutputLength+1;
					TimeNextAction=TimeNextAction+NextCharDelay();
					TextOutput=TextInput.substr(0,OutputLength);
					TextCursor=CursorChar;
				}
				else
				{
					StatemachineState=2;
					CursorTimer=CurrentTime+500;
				}
			}
			break;
			
		case 2://Init wait start fade out
			if (DisplayTime==0)
			{
				StatemachineState=6;
			}
			else
			{
				TimeNextAction=CurrentTime+DisplayTime;
				StatemachineState=3;
			}	
			break;
			
		case 3://Check if fade out should start
			if(TimeNextAction-CurrentTime<0)
			{
				StatemachineState=4;
			}
			break;
			
		case 4://Initialize Fade Output
			StartTimeFadeout=CurrentTime;
			StatemachineState=5;
			break;
			
		case 5://fadeOut
			if (StartTimeFadeout+FadeOutTime-CurrentTime<0)
			{
				StatemachineState=6;
				FontOpacity=0;
			}
			else
			{
				FontOpacity=(1-(CurrentTime-StartTimeFadeout)/FadeOutTime)*100;
			}
			break;
			
		case 6://finished
			//do nothing and wait
			break;
		
		default:
			StatemachineState=0;
	} 
	
	
	if (StatemachineState>=2)
	{
		if (CursorTimer-CurrentTime<0)
		{
			CursorTimer=CursorTimer+500;
			
			if (TextCursor==CursorChar)
			{
				TextCursor='';
			}
			else
			{
				TextCursor=CursorChar;
			}
		}
	}
	
	
	var ReturnValue="";
	if (CursorShow == 1)
	{
		ReturnValue	= PreText+TextOutput+TextCursor;
	}
	else
	{
		ReturnValue	= PreText+TextOutput;
	}	
	
	print('Statevar: ');
	print(StatemachineState);
	print('\n');
	
	
	return [ReturnValue,FontOpacity];
}


function NextCharDelay()
{
	if (TimeBetweenChars==0)
	{
		return Math.floor(Math.random()*100);
	}
	else
	{
		return TimeBetweenChars;
	}
	
}


function DebugOutput(DebugText, DebugValue)
{
	print(DebugText);
	print(': ');
	print(DebugValue);
	print('\n');
}

